# -*- coding: utf-8 -*-
require 'mscorlib'
require 'System.Windows.Forms'
require 'System.Drawing'

class FormBuildDialog

  def initialize(pass = 1, thread = 2)
    @value_pass = pass
    @value_thread = thread
  end

  attr_accessor :value_pass
  attr_accessor :value_thread

  def do
    # - button
    button_cancel = System::Windows::Forms::Button.new()
    button_cancel.Location = System::Drawing::Point.new(190, 94)
    button_cancel.Name = 'button_cancel'
    button_cancel.Size = System::Drawing::Size.new(75, 23)
    button_cancel.TabIndex = 0
    button_cancel.Text = 'Cancel'
    button_cancel.UseVisualStyleBackColor = true
    button_cancel.DialogResult = System::Windows::Forms::DialogResult.Cancel
    button_ok = System::Windows::Forms::Button.new()
    button_ok.Location = System::Drawing::Point.new(109, 94)
    button_ok.Name = 'button_ok'
    button_ok.Size = System::Drawing::Size.new(75, 23)
    button_ok.TabIndex = 1
    button_ok.Text = 'OK'
    button_ok.UseVisualStyleBackColor = true
    button_ok.DialogResult = System::Windows::Forms::DialogResult.OK
    # - numelic spin
    numericUpDown1 = System::Windows::Forms::NumericUpDown.new()
    numericUpDown1.Location = System::Drawing::Point.new(12, 38)
    numericUpDown1.Size = System::Drawing::Size.new(57, 19)
    numericUpDown1.Maximum = 10
    numericUpDown1.Minimum = 1
    numericUpDown1.Name = 'numericUpDown1'
    numericUpDown1.TabIndex = 2
    numericUpDown1.Value = @value_pass
    numericUpDown1.Click{|sender, e|
      @value_pass = numericUpDown1.Value
    }
    numericUpDown2 = System::Windows::Forms::NumericUpDown.new()
    numericUpDown2.Location = System::Drawing::Point.new(12, 60)
    numericUpDown2.Size = System::Drawing::Size.new(57, 19)
    numericUpDown2.Maximum = 64
    numericUpDown2.Minimum = 1
    numericUpDown2.Name = 'numericUpDown2'
    numericUpDown2.TabIndex = 3
    numericUpDown2.Value = @value_thread
    numericUpDown2.Click{|sender, e|
      @value_thread = numericUpDown2.Value
    }
    # - label
    label1 = System::Windows::Forms::Label.new()
    label1.AutoSize = true
    label1.Location = System::Drawing::Point.new(12, 9)
    label1.Name = 'label1'
    label1.Size = System::Drawing::Size.new(160, 12)
    label1.Text = 'Calculate a pass carving a pattern.'
    label2 = System::Windows::Forms::Label.new()
    label2.AutoSize = true
    label2.Location = System::Drawing::Point.new(80, 40)
    label2.Name = 'label2'
    label2.Size = System::Drawing::Size.new(82, 12)
    label2.Text = 'The number of times of the carving.'
    label3 = System::Windows::Forms::Label.new()
    label3.AutoSize = true
    label3.Location = System::Drawing::Point.new(80, 62)
    label3.Name = 'label2'
    label3.Size = System::Drawing::Size.new(82, 12)
    label3.Text = 'The number of using thread.'

    # --- this form
    form = System::Windows::Forms::Form.new()
    form.ClientSize = System::Drawing::Size.new(277, 129)
    form.MaximizeBox = false
    form.MinimizeBox = false
    form.ShowIcon = false
    form.Text = 'Build pass'
    form.FormBorderStyle = System::Windows::Forms::FormBorderStyle.FixedDialog
    form.StartPosition = System::Windows::Forms::FormStartPosition.CenterParent
    form.ResumeLayout(false)
    form.Controls.Add(button_cancel)
    form.Controls.Add(button_ok)
    form.Controls.Add(numericUpDown1)
    form.Controls.Add(numericUpDown2)
    form.Controls.Add(label1)
    form.Controls.Add(label2)
    form.Controls.Add(label3)
    form.PerformLayout()

    # --- do modal
    form.ShowDialog()
  end

end
